#include <stdio.h>
#include <signal.h>
#include <setjmp.h>

#undef ulong
#define ulong unsigned long

static sigjmp_buf	jmpbuf;

extern int mprprint(int, char *, ...);

#define getfp(ap)	(ap-2)
#define getpc(fp)	(fp[1])

static void
mprsigsegv(int sig)
{
	siglongjmp(jmpbuf, 1);
}

void
mprbt(int fd)
{
	ulong pc, *fp = getfp((ulong *)&fd);
	struct sigaction sa, osa;
	sigset_t mask, omask;

	sigemptyset(&mask);
	sigaddset(&mask, SIGSEGV);
	sigprocmask(SIG_UNBLOCK, &mask, &omask);
	sa.sa_handler = mprsigsegv;
	sa.sa_flags = 0;
	sigemptyset(&sa.sa_mask);
	sigaction(SIGSEGV, &sa, &osa);

	if (sigsetjmp(jmpbuf, 1))
		goto done;
	while (fp && *fp && (pc = getpc(fp))) {
		mprprint(fd, "%U:", pc-1);
		fp = (ulong *)*fp;
	}
done:
	sigaction(SIGSEGV, &osa, 0);
	sigprocmask(SIG_SETMASK, &omask, 0);
}
